<?php
/**
* @version		$ 1.2 2009-10$
* @package		Joomla
* @subpackage	IPricecalc
* @copyright	Copyright (C) 2009 LoT studio group. All rights reserved.
* @license		The commercial licence http://www.lot-studio.ru/license-ipricecalc
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.controller' );

require_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_ipricecalc'.DS.'tables'.DS.'ipricecalc.php');
require_once(JPATH_COMPONENT.DS.'views'.DS.'order.php');

class IPricecalcControllerOrder extends JController
{
	/**
	 * Constructor
	 */
	function __construct( $config = array() )
	{
		parent::__construct( $config );
		$this->registerTask( 'savetemplate',	'savetemplate' );
		$this->registerTask( 'vieworder',		'vieworder' );
		$this->registerTask( 'sendmanager',		'sendmanager' );
		$this->registerTask( 'sendcustomer',	'sendcustomer' );
	}

	function display()
	{
		global $mainframe;

		$db					=& JFactory::getDBO();
		$table =& JTable::getInstance('Iprice_order', 'JTable');
		$context			= 'com_ipricecalc.orders';
		
		$filter_order		= $mainframe->getUserStateFromRequest( $context.'filter_order', 		'filter_order', 	'ipom.orderno',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $context.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );
		$search 			= $mainframe->getUserStateFromRequest( $context.'search', 			'search', 			'',				'string' );
		$search 			= JString::strtolower( $search );

		$limit		= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart	= $mainframe->getUserStateFromRequest($context.'.limitstart', 'limitstart', 0, 'int');
		$table->SetQuery($search, $filter_order, $filter_order_Dir);
		$total = $table->GetCount();

		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );

		$rows = $table->GetList($pageNav->limitstart, $pageNav->limit );

		// table ordering
		$lists['order_Dir']	= $filter_order_Dir;
		$lists['order']		= $filter_order;

		// search filter
		$lists['search']= $search;
		
		IPricecalcViewOrder::orders( $rows, $pageNav, $lists, $context );

//		HTML_ipricecalc::showIPriceOrders( $rows, $pageNav, $option, $lists );
	
	}

	function vieworder()
	{
		$cid = JRequest::getVar('cid', 0, '', 'int');
		if ($cid)
			IPricecalcViewOrder::order($cid);
	}

	function remove()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$this->setRedirect( 'index.php?option=com_ipricecalc&c=order' );

		// Initialize variables
		$db		=& JFactory::getDBO();
		$cid	= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$table =& JTable::getInstance('Iprice_order', 'JTable');
		$n		= count( $cid );

		for ($i = 0; $i < $n; $i++)
		{
			if (!$table->delete( (int) $cid[$i] )) {
				return JError::raiseWarning( 500, $table->getError() );
			}
		}

		$this->setMessage( JText::sprintf( 'Items removed', $n ) );
	}
	
	function savetemplate()
	{
		global $mainframe;

		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		// Initialize variables
		$db			= & JFactory::getDBO();

		$cid		= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$templatename	= JRequest::getVar( 'templatename', array (0), 'post', 'array' );		
		$redirect	= JRequest::getVar( 'redirect', 0, 'post', 'int' );
		$rettask	= JRequest::getVar( 'returntask', '', 'post', 'cmd' );
		$total		= count($cid);
		$conditions	= array ();

		JArrayHelper::toInteger($cid, array(0));
		JArrayHelper::toString($templatename, array(0));
		
		// Instantiate an article table object
		$row = & JTable::getInstance('Iprice_order', 'JTable');

		// Update the ordering for items in the cid array
		for ($i = 0; $i < $total; $i ++)
		{
			$row->load( (int) $cid[$i] );
			$templatename[$i] = trim($templatename[$i]);
			if ($templatename[$i]) {
				$row->istemplate = 1;
				$row->templatename = $templatename[$i];
			} else {
				$row->istemplate = 0;
				$row->templatename = "";
			}
			if (!$row->store()) {
				JError::raiseError( 500, $db->getErrorMsg() );
				return false;
			}
		}
		$this->setMessage( JText::_('Templates saved') );
		$this->setRedirect( 'index.php?option=com_ipricecalc&c=order' );
	}
	
	function cancel()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$this->setRedirect( 'index.php?option=com_ipricecalc&c=order' );
	}
	
	function sendmanager()
	{
		global $mainframe;	
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
				
		$db		=& JFactory::getDBO();
		$cid	= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$table =& JTable::getInstance('Iprice_order', 'JTable');
		$n		= count( $cid );
		$msg = "";
		for ($i = 0; $i < $n; $i++)
		{
			$table->load((int) $cid[$i]);
			if ($table->orderno && $table->userid) {
				$contact_user = JUser::getInstance($table->userid);
				$email_to = $contact_user->get('email');
				$FromName 	= $mainframe->getCfg('fromname');
				$subj =  $FromName.JText::_('E-MAIL SUBJECT').' '.JText::_('ORDER NO').$table->orderno;
				$body 	= getOrderHTMLPage($table->orderno);
				$files = getOrderFiles($orderno);
				if (sendMailTo ($email_to, $table->email, $table->fio, $subj, $body, $files))
					$msg = JText::_("Order(s) sent to manager");
			}
		}
		$this->setRedirect( 'index.php?option=com_ipricecalc&c=order', $msg );
	}
	
	function sendcustomer()
	{
		global $mainframe;	
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$db		=& JFactory::getDBO();
		$cid	= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$table =& JTable::getInstance('Iprice_order', 'JTable');
		$n		= count( $cid );
		$msg = "";
		for ($i = 0; $i < $n; $i++)
		{
			$table->load((int) $cid[$i]);
			if ($table->orderno && $table->userid) {
				$contact_user = JUser::getInstance($table->userid);
				$email_from = $contact_user->get('email');
				$name_from = $contact_user->get('name');
				$FromName 	= $mainframe->getCfg('fromname');
				$subj =  $FromName.JText::_('E-MAIL SUBJECT').' '.JText::_('ORDER NO').$table->orderno;
				$body 	= getOrderHTMLPage($table->orderno);
				$files = getOrderFiles($orderno);				
				if (sendMailTo ($table->email, $email_from, $name_from, $subj, $body, $files))
					$msg = JText::_("Order(s) sent to customer");
			}
		}
		$this->setRedirect( 'index.php?option=com_ipricecalc&c=order', $msg );
	}
	
}