<?php
/**
* @version		$ 1.2 2009-10$
* @package		Joomla
* @subpackage	IPricecalc
* @copyright	Copyright (C) 2009 LoT studio group. All rights reserved.
* @license		The commercial licence http://www.lot-studio.ru/license-ipricecalc
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.controller' );

require_once( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_ipricecalc'.DS.'tables'.DS.'section.php');
require_once( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_ipricecalc'.DS.'helpers'.DS.'html.php');
require_once(JPATH_COMPONENT.DS.'views'.DS.'section.php');

class IPricecalcControllerSection extends JController
{
	/**
	 * Constructor
	 */
	function __construct( $config = array() )
	{
		parent::__construct( $config );
		// Register Extra tasks
		$this->registerTask( 'add',		'edit' );
		$this->registerTask( 'apply',		'save' );
		$this->registerTask( 'unpublish',	'publish' );
		$this->registerTask( 'orderup',		'reorder' );
		$this->registerTask( 'orderdown',	'reorder' );
		$this->registerTask( 'saveorder',	'saveorder' );		
	}

	/**
	 * Display the list of banners
	 */
	function display()
	{
		global $mainframe;

		$db =& JFactory::getDBO();

		$context			= 'com_ipricecalc.sections';
		
		$filter_order		= $mainframe->getUserStateFromRequest( $context.'filter_order', 'filter_order', 'ordering',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $context.'filter_order_Dir', 'filter_order_Dir',	'', 'word' );
		$filter_state 		= $mainframe->getUserStateFromRequest( $context.'filter_state', 'filter_state', '', 'word' );
		$search			= $mainframe->getUserStateFromRequest( $context.'search', 'search', '',	'string' );
		$search			= JString::strtolower( $search );
		
		$limit		= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart	= $mainframe->getUserStateFromRequest($context.'.limitstart', 'limitstart', 0, 'int');

		$table =& JTable::getInstance('Iprice_section', 'JTable');		
		$table->SetQuery($filter_state, $search, $filter_order, $filter_order_Dir);
		$total = $table->GetCount();

		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );

		$rows = $table->GetList($pageNav->limitstart, $pageNav->limit );


		$javascript = 'onchange="document.adminForm.submit();"';


		// state filter
		$lists['state']	= JHTML::_('grid.state',  $filter_state );

		// table ordering
		$lists['order_Dir']	= $filter_order_Dir;
		$lists['order']		= $filter_order;

		// search filter
		$lists['search']= $search;
		
		IPricecalcViewSection::sections( $rows, $pageNav, $lists );		
	}

	function edit()
	{
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
		$edit = ($this->_task == 'edit');
		if ($edit) {
			$cid	= JRequest::getVar('cid', array(0), 'method', 'array');
			$cid	= array((int) $cid[0]);
		} else {
			$cid	= array( 0 );
		}
	
		$option = JRequest::getCmd('option');

		JArrayHelper::toInteger($cid, array(0));

		$row =& JTable::getInstance('Iprice_section', 'JTable');
		// load the row from the db table
		$row->load( $cid[0] );

		if ($edit) {
			// do stuff for existing records
			$row->checkout($user->get('id'));
		} else {
			// do stuff for new records
			$row->ordering 	= 0;
		}
		$lists = array();

		// build the html select list for ordering
		$query = $row->GetOrderQuery();
		if($edit)
			$lists['ordering'] = JHTML::_('list.specificordering',  $row, $cid[0], $query );
		else
			$lists['ordering'] = JHTML::_('list.specificordering',  $row, '', $query );


		$lists['published']	= JHTML::_('select.booleanlist',  'published', '', $row->published );

		$lists['owner']	= JHTML::_('list.users',  'owner', intval( $row->owner ),NULL,NULL, 'name',0);
		$lists['discid'] = JHTMLIpriceList::discount('discid', intval( $row->discid ));

		// get params definitions
		$file 	= JPATH_ADMINISTRATOR .'/components/com_ipricecalc/ipricecalc_items.xml';

		IPricecalcViewSection::section( $row, $lists);
	}

	/**
	 * Save method
	 */
	function save()
	{
		global $mainframe;

		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		// Initialize variables
		$db		=& JFactory::getDBO();
		$row	=& JTable::getInstance('Iprice_section', 'JTable');
		$post = JRequest::get( 'post' );
	
		// fix up special html fields
		$post['description'] = JRequest::getVar( 'description', '', 'post', 'string', JREQUEST_ALLOWRAW );
		if (!$row->bind( $post )) {
			JError::raiseError(500, $row->getError() );
		}
		// save params
		$params = JRequest::getVar( 'params', array(), 'post', 'array' );
		if (is_array( $params )) {
			$txt = array();
			foreach ( $params as $k=>$v) {
				$txt[] = "$k=$v";
			}
			$row->params = implode( "\n", $txt );
		}

		// save to a copy, reset the primary key
		if ($task == 'save2copy') {
			$row->id = 0;
		}

		// pre-save checks
		if (!$row->check()) {
			JError::raiseError(500, $row->getError() );
		}

		// if new item, order last in appropriate group
		if (!$row->id) {
			$row->ordering = $row->getNextOrder();
		}

		// save the changes
		if (!$row->store()) {
			JError::raiseError(500, $row->getError() );
		}
		$row->checkin();

		$task = JRequest::getCmd( 'task' );
	
		switch ($task)
		{
			case 'apply':
			case 'save2copy':
				$msg	= JText::sprintf( 'Changes to X saved', JText::_('Section') );
				$link	= 'index.php?option=com_ipricecalc&c=section&task=edit&cid[]='. $row->id .'';
				break;

			case 'save2new':
				$msg	= JText::sprintf( 'Changes to X saved', JText::_('Section') );
				$link	= 'index.php?option=com_ipricecalc&c=section&task=edit';
				break;

			case 'save':
			default:
				$msg	= JText::_( 'Price section saved' );
				$link	= 'index.php?option=com_ipricecalc&c=section';
				break;
		}


		$this->setRedirect( $link, $msg );
	}

	function cancel()
	{
		global $mainframe;

		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$this->setRedirect( 'index.php?option=com_ipricecalc&c=section' );
		// Initialize variables
		$db =& JFactory::getDBO();
		$row =& JTable::getInstance('Iprice_section', 'JTable');
		$row->bind( JRequest::get( 'post' ));
		$row->checkin();
	}


	function copy()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$this->setRedirect( 'index.php?option=com_ipricecalc&c=section' );
	}

	function publish()
	{
		global $mainframe;
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$this->setRedirect( 'index.php?option=com_ipricecalc&c=section' );
	// Initialize variables
		$db 	=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
		
		$cid		= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$task		= JRequest::getCmd( 'task' );
		$publish	= ($task == 'publish');
		$n			= count( $cid );
		
		if (empty( $cid )) {
			return JError::raiseWarning( 500, JText::_( 'No items selected' ) );
		}
		JArrayHelper::toInteger($cid);
		$cids = implode( ',', $cid );
		
		$query = 'UPDATE #__iprice_sections'
		. ' SET published = ' . (int) $publish
		. ' WHERE id IN ( '. $cids .' )'
		. ' AND ( checked_out = 0 OR ( checked_out = '. (int) $user->get('id') .' ) )'
		;
		$db->setQuery( $query );
		if (!$db->query()) {
			JError::raiseError(500, $db->getErrorMsg() );
		}
		if (count( $cid ) == 1) {
			$row =& JTable::getInstance('Iprice_section', 'JTable');
			$row->checkin( intval( $cid[0] ) );
		}
		$this->setMessage( JText::sprintf( $publish ? 'Items published' : 'Items unpublished', $n ) );		
	}

	function remove()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$this->setRedirect( 'index.php?option=com_ipricecalc&c=section' );

		// Initialize variables
		$db =& JFactory::getDBO();
		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$n		= count( $cid );
		JArrayHelper::toInteger( $cid );
		if (count( $cid )) {
			$cids = implode( ',', $cid );

			$query = 'select count(*) from #__iprice_categories WHERE secid IN ( '. $cids .' )';
			$db->setQuery( $query );
			$cnt = $db->loadResult();
			if ($cnt)
				return JError::raiseWarning( 500, JText::_( 'One or more sections has categories' ) );

			$query = 'DELETE FROM #__iprice_sections'
			. ' WHERE id IN ( '. $cids .' )'
			;
			$db->setQuery( $query );
			if (!$db->query()) {
				JError::raiseWarning( 500, $db->getError() );
			}
		}
		$this->setMessage( JText::sprintf( 'Items removed', $n ) );
	}

	/**
	 * Save the new order given by user
	 */
	function reorder()
	{
		global $mainframe;

		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$this->setRedirect( 'index.php?option=com_ipricecalc&c=section' );
		
		$task	= JRequest::getCmd('task');
		$cid		= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$order		= JRequest::getVar( 'order', array(), 'post', 'array' );
		$inc = ($task == 'orderup' ? -1 : 1);
		$uid = (int) $cid[0];

		// Initialize variables
		$db =& JFactory::getDBO();

		$row =& JTable::getInstance('Iprice_section', 'JTable');
		$row->load( $uid );
		$row->move( $inc );

		$this->setMessage( JText::_('New ordering saved') );
	}
	
	function saveorder()
	{
		global $mainframe;

		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		// Initialize variables
		$db			= & JFactory::getDBO();

		$cid		= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$order		= JRequest::getVar( 'order', array (0), 'post', 'array' );
		$redirect	= JRequest::getVar( 'redirect', 0, 'post', 'int' );
		$rettask	= JRequest::getVar( 'returntask', '', 'post', 'cmd' );
		$total		= count($cid);
		$conditions	= array ();

		JArrayHelper::toInteger($cid, array(0));
		JArrayHelper::toInteger($order, array(0));

		// Instantiate an article table object
		$row = & JTable::getInstance('Iprice_section', 'JTable');

		// Update the ordering for items in the cid array
		for ($i = 0; $i < $total; $i ++)
		{
			$row->load( (int) $cid[$i] );
			if ($row->ordering != $order[$i]) {
				$row->ordering = $order[$i];
				if (!$row->store()) {
					JError::raiseError( 500, $db->getErrorMsg() );
					return false;
				}
				// remember to updateOrder this group
				$condition = '';
				$found = false;
				foreach ($conditions as $cond)
					if ($cond[1] == $condition) {
						$found = true;
						break;
					}
				if (!$found)
					$conditions[] = array ($row->id, $condition);
			}
		}

		// execute updateOrder for each group
		foreach ($conditions as $cond)
		{
			$row->load($cond[0]);
			$row->reorder($cond[1]);
		}
		$this->setMessage( JText::_('New ordering saved') );
		$this->setRedirect( 'index.php?option=com_ipricecalc&c=section' );
	}

}
