<?php

/**
* @version		$ 1.2 2009-10$
* @package		Joomla
* @subpackage	IPricecalc
* @copyright	Copyright (C) 2009 LoT studio group. All rights reserved.
* @license		The commercial licence http://www.lot-studio.ru/license-ipricecalc
*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );
jimport('joomla.application.component.model');
JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_ipricecalc'.DS.'tables');
require_once( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_ipricecalc'.DS.'tables'.DS.'ipricecalc.php');

class IPriceCalcModelBasket extends JModel
{

	function getCategories( $options=array(), $catids )
	{
		$table =& JTable::getInstance('Iprice_basket', 'JTable');
		$table->SetQuery('PP','','','','',''); 
		return $table->GetList();
	}
	

	function getItemsCount( $options=array() )
	{
		$table =& JTable::getInstance('Iprice_basket', 'JTable');
		$table->SetQuery('PP'); 
		return $table->GetCount();
	}
	
	function getNextOrderNo()
	{
		$db = JFactory::getDBO();
		$query = 'SELECT MAX(orderno) from #__iprice_order_main';
		$db->setQuery($query);
		$nextorder = 1 + (int) $db->LoadResult();
		return $nextorder;
	}

	// SHould be DELETE!!
	function updateTotals($orderno,$currcode = 'RUR')
	{
		$db = JFactory::getDBO();
		$query = 'update #__iprice_order as ipo set amount = (select cost from #__iprice_item as ipi where ipi.id=ipo.itemid ) where orderno = '. (int) $orderno;
		$db->setQuery($query);
		if (!$db->query())
			JError::raiseError( 500, $db->stderr());
			
		$curr =& JTable::getInstance('Iprice_curr', 'JTable');
		$curr->load($currcode);
		if ($curr->rate && $curr->rate!=1) {
			$query = 'update #__iprice_order as ipo set amount = amount * '.$curr->rate.' where orderno = '. (int) $orderno;
			$db->setQuery($query);
			if (!$db->query())
				JError::raiseError( 500, $db->stderr());
		}
			
		$query = 'update #__iprice_order_main as ipom set totalamount = (select sum(amount*countitems) from #__iprice_order as ipo where ipo.orderno=ipom.orderno ) where orderno = '. (int) $orderno;
		$db->setQuery($query);
		if (!$db->query())
			JError::raiseError( 500, $db->stderr());
	}
	
	function insOrder(&$items,&$contact, $orderno,$currcode = 'RUR', & $pparams, $salestax = 0, $total = 0, $taxamount = 0)
	{
		if (!$contact)
		  return false;
		  
		$usecents = (int) $pparams->get('usecents','1');
		$showprices = (int) $pparams->get('showprices','1');
		$showorderdesc = (int) $pparams->get('showorderdesc','1');
		$userid = (int) $pparams->get('manageruserid','62');
	  
		$db = JFactory::getDBO();
		
		$query = 'INSERT INTO #__iprice_order_main ( orderno, orderdate, fio, firm, email, phone, comments , totalamount, currcode, usecents, showprices, showorderdesc, userid)' .
					' VALUES ( '.(int) $orderno.', NOW() , '.$db->Quote($contact->fio).', '.$db->Quote($contact->firm).', '.$db->Quote($contact->email).', '.$db->Quote($contact->phone).', '.$db->Quote($contact->comments).', 0 ,'.$db->Quote($currcode).', '.(int)$usecents.', '.(int)$showprices.', '.(int)$showorderdesc.' ,'.(int)$userid.' )';
		
		$db->setQuery($query);
		if (!$db->query())
			JError::raiseError( 500, $db->stderr());
					
		foreach ($items as $item) {
			if ($item->count) {
				$fname="";
				if ( $item->filename && file_exists($item->tmp_dirname.$item->tmp_filename)) {
					if (rename($item->tmp_dirname.$item->tmp_filename, $item->tmp_dirname.$orderno."-".$item->filename))
						$fname=$item->tmp_dirname.$orderno."-".$item->filename;
				}
			
				$query = 'INSERT INTO #__iprice_order ( orderno, itemid, countitems, amount, origamount, discdispl, secid, section, catid, category, name, shortdesc, description, filename, unit)' .
						' values ( '.(int) $orderno.', '.(int) $item->id.', '.(int) $item->count.', '.(float)$item->cost.' , '.(float)$item->origcost.' , '.$db->Quote($item->discdispl).', '.$item->secid.','. $db->Quote($item->section).', '.$item->catid.', '.$db->Quote($item->category).', '.$db->Quote($item->name).', '.$db->Quote($item->shortdesc).', '.$db->Quote($item->description) .', '.$db->Quote($fname).', '.$db->Quote($item->unit).') ';
				$db->setQuery($query);
				if (!$db->query())
					JError::raiseError( 500, $db->stderr());
			}
		}
		$query = 'update #__iprice_order_main set totalamount = '.(float)$total . ', salestax = '. (float)$salestax. ', taxamount = '. (float)$taxamount .' where orderno = '. (int) $orderno;
		$db->setQuery($query);
		if (!$db->query())
			JError::raiseError( 500, $db->stderr());
	}
	
	function insOrderToBasket( $orderno)
	{
		//$msg = 'Count items '.count($items);
		$db = JFactory::getDBO();
		$query = 'INSERT INTO #__iprice_basket ( sessionid , itemid,  itemcount)' .
				' select "'.session_id().'", itemid, countitems  from #__iprice_order where orderno='.(int) $orderno;
		$db->setQuery($query);
		if (!$db->query())
		JError::raiseError( 500, $db->stderr());
	}
	
	function getOrder( $orderno )
	{
		$table =& JTable::getInstance('Iprice_order', 'JTable');
		return $table->getOrder($orderno);
	}
	
	function getOrderItems( $orderno )
	{
		$table =& JTable::getInstance('Iprice_order', 'JTable');
		return $table->getOrderItems($orderno);
	}
	
	function emptyBasket() {
		$table =& JTable::getInstance('Iprice_basket', 'JTable');
		$table->emptySession('PP'); 
	}
	
}