CREATE TABLE IF NOT EXISTS `#__iprice_sections` (
  `id` INT(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `alias` varchar(255) NOT NULL,
  `ordering` int(11) NOT NULL,
  `discid` int(11),
  `checked_out` int(11) unsigned default '0',
  `checked_out_time` datetime default '0000-00-00 00:00:00',
  `published` tinyint(1) unsigned NOT NULL default '1',
  `owner` int(11) unsigned NOT NULL default '62',
  `params` text,
  `description` TEXT,
  PRIMARY KEY (`id`),
  KEY `idx_name` (`name`(255)),
  KEY `idx_checked_out` (`checked_out`)
)  AUTO_INCREMENT=10 DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__iprice_categories` (
  `id` INT(11) NOT NULL AUTO_INCREMENT,
  `secid` INT(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `alias` varchar(255) NOT NULL,
  `discid` int(11),
  `ordering` int(11) NOT NULL,
  `checked_out` int(11) unsigned default '0',
  `checked_out_time` datetime default '0000-00-00 00:00:00',
  `published` tinyint(1) unsigned NOT NULL default '1',
  `params` text,  
  `description` TEXT,
  PRIMARY KEY (`id`),
  KEY `idx_name` (`name`(255)),
  KEY `idx_checked_out` (`checked_out`),
  KEY `idx_secid` (`secid`)
)  AUTO_INCREMENT=10 DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__iprice_item` (
  `id` INT(11) NOT NULL AUTO_INCREMENT,
  `catid` INT(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `item_type` tinyint(1) default 0,
  `cost` decimal(15,2) NOT NULL default 0,
  `showcount` TINYINT(1) NOT NULL default 1,
  `radiogroup` INT(5) unsigned NOT NULL default 0,
  `discid` int(11),  
  `enable_file` tinyint(1) unsigned default '0',
  `unit` varchar(50),
  `ordering` int(11) NOT NULL,
  `checked_out` int(11) unsigned default '0',
  `checked_out_time` datetime default '0000-00-00 00:00:00',
  `published` tinyint(1) unsigned NOT NULL default '1',
  `shortdesc` TEXT,
  `description` TEXT,
  `params` text,  
  PRIMARY KEY (`id`),
  KEY `idx_name` (`name`(100)),
  KEY `idx_checked_out` (`checked_out`),
  KEY `idx_catid` (`catid`)
)  AUTO_INCREMENT=10 DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__iprice_order_main` (
  `orderno` int(11) NOT NULL,
  `orderdate` date NOT NULL,
  `currcode` text(3) NOT NULL,  
  `fio` varchar(255),
  `firm` varchar(255),
  `email` varchar(50),
  `phone` varchar(50) NOT NULL,
  `totalamount` decimal(12,2) NOT NULL DEFAULT 0,
  `salestax` tinyint(2) unsigned,
  `taxamount` decimal(12,2) NOT NULL DEFAULT 0,
  `istemplate` tinyint(1) default '0',
  `templatename` varchar(50),
  `checked_out` int(11) unsigned default '0',
  `checked_out_time` datetime default '0000-00-00 00:00:00',
  `usecents` tinyint(1) default 1,
  `showprices` tinyint(1) default 1,
  `showorderdesc` tinyint(1) default 1,
  `userid` int(11) default 62,
  `comments` text NOT NULL,  
  PRIMARY KEY  (`orderno`)
)  DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__iprice_order` (
  `id` int(11) NOT NULL auto_increment,
  `orderno` int(11) NOT NULL,
  `itemid` int(11) NOT NULL,
  `countitems` int(8) NOT NULL,
  `amount` decimal(12,2) NOT NULL DEFAULT 0,
  `origamount` decimal(15,2) DEFAULT 0,
  `unit` varchar(50),  
  `discdispl` varchar(20),
  `secid` int(11),
  `section` varchar(255),
  `catid` int(11),
  `category` varchar(255),
  `name` varchar(255),
  `filename` varchar(500),
  `shortdesc` TEXT,
  `description` TEXT,
  PRIMARY KEY  (`id`),
  KEY `orderno` (`orderno`)
)  AUTO_INCREMENT=10 DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__iprice_curr` (
  `currcode` text(3) NOT NULL,
  `currdate` date,
  `rate` decimal(9,4) NOT NULL default '1',
  `symbol` text,
  `symplace` int(1),
  `usespace` int(1),
  `checked_out` int(11) unsigned default '0',
  `checked_out_time` datetime default '0000-00-00 00:00:00',
  PRIMARY KEY  (`currcode`(3))
)  DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__iprice_basket` (
  `id` INT(11) NOT NULL AUTO_INCREMENT,
  `sessionid` varchar(200),
  `itemid` INT(11) NOT NULL,
  `itemcount` int(8),
  `date` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `filename` varchar(255),
  `tmp_dirname` varchar(255),
  `tmp_filename` varchar(255),
  PRIMARY KEY (`id`),
  KEY `idx_sessitm` (`sessionid`,`itemid`),
  KEY `idx_date` (`date`)  
)  AUTO_INCREMENT=10 DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__iprice_importfield` (
  `id` INT(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `position` tinyint(1) NOT NULL default '0',
  `varname` varchar(255) NULL,
  `ordering` int(11) NOT NULL,
  `checked_out` int(11) unsigned default '0',
  `checked_out_time` datetime default '0000-00-00 00:00:00',
  `published` tinyint(1) unsigned NOT NULL default '1',
  `owner` int(11) unsigned NOT NULL default '62',
  `params` text,
  `instext` TEXT,
  PRIMARY KEY (`id`),
  KEY `idx_name` (`name`(255)),
  KEY `idx_checked_out` (`checked_out`)
)  AUTO_INCREMENT=10 DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__iprice_discount` (
  `id` INT(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `type` tinyint(1) unsigned NOT NULL default '0',
  `kind` tinyint(1) unsigned NOT NULL default '0',
  `value1` decimal(15,2),
  `disc1` decimal(15,2),
  `value2` decimal(15,2),
  `disc2` decimal(15,2),
  `value3` decimal(15,2),
  `disc3` decimal(15,2),
  `value4` decimal(15,2),
  `disc4` decimal(15,2),
  `value5` decimal(15,2),
  `disc5` decimal(15,2),
  `checked_out` int(11) unsigned default '0',
  `checked_out_time` datetime default '0000-00-00 00:00:00',
  `published` tinyint(1) unsigned NOT NULL default '1',
  PRIMARY KEY (`id`),
  KEY `idx_name` (`name`(255)),
  KEY `idx_checked_out` (`checked_out`)
)  AUTO_INCREMENT=10 DEFAULT CHARSET=utf8;


insert IGNORE into `#__iprice_importfield` values (1,'Изображение',0,null,1,null,null,1,62,null,'<img src="%s" style="background-color:#EEEEEE; border:1px solid #999999; margin-right: 10px; padding: 5px; float: left;" id="smartresize" width="40px" />');
insert IGNORE into `#__iprice_importfield` values (2,'Изображение 2',2,'image',2,null,null,1,62,null,'<img src="%s" style="background-color:#EEEEEE; border:1px solid #999999; margin-right: 10px; padding: 5px;" id="smartresize" width="40px" />');

insert IGNORE into `#__iprice_curr` values ('RUR','2009-09-05 00:00:00',1,'р.',0,1,0,NULL) ON DUPLICATE KEY UPDATE checked_out=checked_out;
insert IGNORE into `#__iprice_curr` values ('USD','2009-09-05 00:00:00',0.0318,'$',1,0,0,NULL) ON DUPLICATE KEY UPDATE checked_out=checked_out;
insert IGNORE into `#__iprice_curr` values ('EUR','2009-09-05 00:00:00',0.0220,'€',0,1,0,NULL) ON DUPLICATE KEY UPDATE checked_out=checked_out;
