<?php
/**
 * IPricecalc Content Plugin
 *
 * @package		Joomla
 * @subpackage	IPricecalc Content Plugin
 * @copyright Copyright (C) 2009 LoT studio. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @author igort
 *
 */

// no direct access
defined( '_JEXEC' ) or die();

jimport( 'joomla.plugin.plugin' );
jimport( 'joomla.application.menu' );
require_once( JPATH_SITE.DS.'components'.DS.'com_ipricecalc'.DS.'controller.php');

class plgContentIPricecalc extends JPlugin
{
    function plgContentIPricecalc( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}
	
	function onPrepareContent( &$article, &$params, $limitstart )
	{
		global $mainframe;

    	// simple performance check to determine whether bot should process further
    	if ( strpos( $article->text, 'ipricecalc' ) === false ) {
    		return true;
    	}
    	$plugin =& JPluginHelper::getPlugin('content', 'ipricecalc');
	 	$regex = '/{ipricecalc\s*.*?}/i';
    	$pluginParams = new JParameter( $plugin->params );
		preg_match_all( $regex, $article->text, $matches);
		
		$count = count( $matches[0] );

     	// plugin only processes if there are any instances of the plugin in the text
     	if ( $count ) {
     		$this->plgContentProcessIPricecalc( $article, $pluginParams, $matches, $count );
    	}
	}
	
	function plgContentProcessIPricecalc( &$row, &$botParams, &$matches, $count ) {

		for ( $i=0; $i < $count; $i++ )
		{
			$contents = "";
			if (strpos($matches[0][$i],'secid') || strpos($matches[0][$i],'catid') || strpos($matches[0][$i],'itemid')) {
        		preg_match( "#secid=[\"\'-](.*?)[\"\-']#s", $matches[0][$i], $secids );
        		if (isset($secids[1])) $secids = trim($secids[1]);
				  else $secids="";
        		preg_match( "#catid=[\"\'-](.*?)[\"\-']#s", $matches[0][$i], $catids );
        		if (isset($catids[1])) $catids = trim($catids[1]);
				  else $catids="";
        		preg_match( "#itemid=[\"\'-](.*?)[\"\'-]#s", $matches[0][$i], $itemids );
        		if (isset($itemids[1])) $itemids = trim($itemids[1]);
				  else $itemids="";
        		preg_match( "#menuid=[\"\'-](.*?)[\"\'-]#s", $matches[0][$i], $menuid );
        		if (isset($menuid[1])) $menuid = trim($menuid[1]);
				  else $menuid="";
				$menu = & JMenu::getInstance('site');				  
				$link = "";
				if ($menuid) {
					$menuitem = $menu->getItem($menuid);
					if (!$menuitem)
						$contents = '{IPricecalc: menu ID '.$menuid.' not found}';
					else {
						if (!strpos($menuitem->link,'ipricecalc'))
							$contents = '{IPricecalc: menu ID '.$menuid.' not linked to IPrice calculator}';
						else $link = $menuitem->link;
					}

				} else { /* Take parameters from globals, not from menupoint
					$items	= $menu->getItems('link', 'index.php?option=com_ipricecalc&view=price');
					for ($i=0;$i<count($items);$i++) {
						$par = new JParameter($items[$i]->params);
						if (!$par->get("secpriceid","") && !$par->get("catpriceid","")) {
							$menuid = $items[$i]->id;
							$link = $items[$i]->link;
							break;
						}
					}
					if (!$menuid) {
						$items	= $menu->getItems('link', 'index.php?option=com_ipricecalc&view=price&layout=catalog');
						for ($i=0;$i<count($items);$i++) {
							$par = new JParameter($items[$i]->params);
							if (!$par->get("secpriceid","") && !$par->get("catpriceid","")) {
								$menuid = $items[$i]->id;
								$link = $items[$i]->link;
								break;
							}
						}
					}
					*/
				}
/*				if (!$menuid) {
					$contents = '{IPricecalc: menu item for component not found}';
				}
*/				
				
				if (!$contents) {
						$controller = new IPriceCalcController();
						if (strpos($link,'view=basket'))
							$contents .= $controller->renderIPriceBasket($menuid);
						else
							$contents .= $controller->renderIPrice($menuid,$secids,$catids,$itemids);
				}
				$row->text = str_replace( $matches[0][$i], $contents, $row->text );
			}
			else {
		 		$load = str_replace( 'ipricecalc', '', $matches[0][$i] );
		 		$load = str_replace( '{', '', $load );
		 		$load = str_replace( '}', '', $load );
		 		$load = trim( $load );
			
				$contents = '';
			
				$menuid = (int)$load;
				if (!$menuid)
					$contents = '{IPricecalc: menu ID requred}';
				else {
				    $menu = & JMenu::getInstance('site');
					$menuitem = $menu->getItem($menuid);
					if (!$menuitem)
						$contents = '{IPricecalc: menu ID '.$menuid.' not found}';
					else {
						if (!strpos($menuitem->link,'ipricecalc'))
							$contents = '{IPricecalc: menu ID '.$menuid.' not linked to IPrice calculator}';
						else {
							$controller = new IPriceCalcController();
							if (strpos($menuitem->link,'view=basket'))
								$contents .= $controller->renderIPriceBasket($menuid);
							else
								$contents .= $controller->renderIPrice($menuid);
						}
					}
				}
			
				$row->text = str_replace( $matches[0][$i], $contents, $row->text );
			}
		}
    }
}

?>