<?php
/**
* @version		$ 1.2 2009-10$
* @package		Joomla
* @subpackage	IPricecalc
* @copyright	Copyright (C) 2009 LoT studio group. All rights reserved.
* @license		The commercial licence http://www.lot-studio.ru/license-ipricecalc
*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );


class JTableIprice_section extends JTable
{
	var $id 				= NULL;
	var $name 				= NULL;
	var $alias 				= NULL;
	var $owner				= 62;
	var $discid				= NULL;
	var $description 		= NULL;
	
	var $checked_out 	= 0;
	var $checked_out_time 	= 0;
	var $ordering 			= NULL;
	var $published 			= 1;
	
// internal variables

	var $_query = "";
	var $_querycount = "";
	var $_where	= "";
	var $_orderby	= "";
	
	/**
	* @param database A database connector object
	*/
	function __construct(&$db)
	{
		parent::__construct( '#__iprice_sections', 'id', $db );
	}


	function check()
	{
		// check for valid name
		if (trim( $this->name ) == '') {
			$this->setError(JText::sprintf( 'must contain a title', JText::_( 'Section') ));
			return false;
		}

		if(empty($this->alias)) {
			$this->alias = $this->name;
		}
		$this->alias = JFilterOutput::stringURLSafe($this->alias);
		if(trim(str_replace('-','',$this->alias)) == '') {
			$datenow =& JFactory::getDate();
			$this->alias = $datenow->toFormat("%Y-%m-%d-%H-%M-%S");
		}

		return true;
	}
	
	function SetQuery($filter_state = "", $search = "",$filter_order = "", $filter_order_Dir = "", $whe = "")
	{
		$db =& JFactory::getDBO();
		
		$this->_query = 'SELECT * FROM #__iprice_sections ';
						;
		$this->_querycount = 'SELECT COUNT(*) FROM #__iprice_sections ';
		$wh = NULL;

		if ( $search ) {
			$wh[] = 'name LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
		}
		
		if ( $filter_state ) {
			if ( $filter_state == 'P' ) {
				$wh[] = 'published = 1';
			} else if ($filter_state == 'U' ) {
				$wh[] = 'published = 0';
			} else if ($filter_state == 'PP' ) {
				$wh[] = 'published = 1';
			}
		}
		
		if ( $whe ) {
		 	$wh[] = $whe;
		}
		
		$this->_where = ( count( $wh ) ? ' WHERE ' . implode( ' AND ', $wh ) : '' );
		
		if ($filter_order == 'ordering' || $filter_order == ''){
			$this->_orderby 	= ' ORDER BY ordering '.' '. $filter_order_Dir ;
		} else {
			$this->_orderby 	= ' ORDER BY '. $filter_order .' '. $filter_order_Dir ;
		}
	}
	
	function GetOrderQuery()
	{
	  return 'SELECT ordering AS value, name AS text FROM #__iprice_sections ORDER BY ordering';
	}
	
	function GetList($limitstart = 0, $limit = 0)
	{
		$db	=& $this->getDBO();
		$db->setQuery( $this->_query . $this->_where . $this->_orderby, $limitstart, $limit);
		$rows = $db->loadObjectList();
		return $rows;
	}
	
	function GetSectionID($wh = null)
	{
		$db	=& $this->getDBO();
		$query = 'select id from #__iprice_sections '.($wh!==null ? ' where  '.$wh : '');
		$db->setQuery($query);
		$rows = $db->loadResultArray();
		return $rows;
	}
	
	
	function GetCount()
	{
		$db	=& $this->getDBO();
		$db->setQuery( $this->_querycount . $this->_where );
		$total = $db->loadResult();
		return $total;
	}
	
}
?>